'Modificado para RapidQ por Jordi Ramos 26/05/2004

'************************************************************************************
'* DLL d'affichage des ombres de boite de dialogue                                   *
'* Auteur : Patrice Ongla                                                           *
'*                                                                            *
'************************************************************************************
'
'Modifi le 18/05/1999

'Cette DLL permet d'ombrer une fentre Windows quelconque.
'Elle projette sur la fentre situe derrire la bote (dite "support de l'ombre") une ombre
'floue en semi-transparence, dcale en bas et  droite.
'Elle est accessible par deux fonctions d'interface : la fonction "Ombrer" et la fonction
'"Ombrer_Std". La 1re offre le parametrage de la profondeur de l'ombre (sa largeur), de son
'intensit et de son flou, la deuxime utilise des valeurs prdfinies pour ces paramtres.

'Le principe de base est le suivant : on cre en mmoire un bitmap compatible avec l'cran
'et on y copie la portion de l'cran correspondant  l'objet  ombrer (la largeur dpend de la
'taille de la fentre  ombrer et de la profondeur de l'ombre demande). On manipule les pixels
'du bitmap mmoire en les assombrissant plus ou moins selon la distance depuis le bord de
'l'objet  ombrer, l'intensit spcifi pour l'ombre et le flou. Enfin, on recopie le bitmap
'modifi  son emplacement sur l'lment ( priori la form) sur lequel l'ombre est projete.

'NB : La recopie est effectue dans le contexte graphique du support de l'ombre (la form situe
'derrire) ce qui prsente l'avantage de ne pas avoir  grer de zone de clipping (zone de rafra-
'chissement) pour viter les peintures inopportunes sur des fentres d'autres programmes. Cependant,
'cela empche aussi de le faire dans les cas o on le souhaiterait (porter l'ombre sur le bureau
'Windows ou dans une autre application par exemple). Pour pouvoir le faire, il faut recopier le
'bitmap dans le contexte graphique de l'cran lui-mme et se dbrouiller tout seul comme un grand
'avec la gestion de la zone de clipping (pas trs accessible en VB, prfrer le C).

'NB : l'image de l'ombre est lie  l'cran physique et pas  la fentre. Ainsi, elle n'est
'pas rafrachie avec l'objet ombr comme un de ses composant normaux. Il appartient donc 
'l'utilisateur de la dll de repeindre l'ombre  chaque rafrachissement de l'objet ombr.

'************************************************************************************

'Option Explicit
$TypeCheck on

Declare FunctionI AttenueOmbre(...) As Double
Declare Function Correct_RGB(Couleur As Long) As Long
Declare SubI Ombrer_Std(...)
Declare Sub Peindre_Ombre(hdc As Long, hWinUnder As Long, Zone As Rect, _
            IntOmbre As Integer, ByVal Flou As Single, Sens As Integer)
Declare Sub Ombrer(HWinObjetAOmbrer As Long, hWinSupportOmbre, IntensiteOmbre As Integer, _
                  ProfondeurOmbre As Integer, FlouOmbre As Single)





'Private Function AttenueOmbre(A As Integer, B As Integer, x As Integer, Optional DeCroissante) As Double
FunctionI AttenueOmbre(...) As Double
'Cette fonction rend le coeff d'attenuation de l'ombre en un point  une
'distance x du dbut de l'ombre en A pour une ombre allant de A  B.
'Elle varie entre 1 et 0 sur [AB] avec des asymptotes horizontales en A et B
'(c'est un cos(x) avec un changement de repre).
'"DeCroissante" indique que l'ombre s'attnue (DeCroissante = True)
'ou qu'elle s'intensifie qd x grandit .

'-----------------------------------------------------------------------
  Dim a as integer, b as Integer, x as Integer, DeCroissante as integer
  a = ParamVal(1) : b = ParamVal(2): x = ParamVal(3)
  if ParamValCount = 4 then DeCroissante = ParamVal(4)
'-----------------------------------------------------------------------
    Dim y As Double
    Dim PI As Double
        
    PI = 4 * Atn(1)
'    If IsMissing(DeCroissante) Then
    If ParamValCount <> 4 Then
        y = (Cos((PI * (x - A) / (B - A))))
        y = (y + 1) / 2
    ElseIf DeCroissante Then
        y = (Cos((PI * (x - A) / (B - A))))
        y = (y + 1) / 2
    Else
        y = (Cos((PI * (A - x) / (A - B))))
        'y = (Cos((PI * (x - A) / (B - A)) + PI))
        y = (y + 1) / 2
    End If
    AttenueOmbre = y
End Function


Function Correct_RGB(Couleur As Long) As Long
'Corrige les valeurs ngatives de couleur RGB et rend 0  la place.
    If Couleur < 0 Then Correct_RGB = 0 Else Correct_RGB = Couleur
End Function

'Sub Ombrer_Std(HWinObjetAOmbrer As Long, Optional hWinSupportOmbre As Long)
SubI Ombrer_Std(...)
'Ombrage avec paramtres prdfinis.
'On passe en paramtre le handle de l'objet  ombrer et celui du support de l'ombre
'voir procdure "Ombrer" pour dtails.
'Si hWinSupportOmbre n'est pas dfini, on ombre sur tout l'arrire plan de la fentre
'de handle HWinObjetAOmbrer.

'-----------------------------------------------------------------------
  Dim HWinObjetAOmbrer As Long, hWinSupportOmbre As Long
  HWinObjetAOmbrer = ParamVal(1)
  if ParamValCount = 2 then hWinSupportOmbre = ParamVal(2)
'-----------------------------------------------------------------------

    If ParamValCount <> 2 Then
        Ombrer HWinObjetAOmbrer, GetDesktopWindow, STD_INTENSITE, STD_PROFONDEUR, STD_FLOU
    Else
        Ombrer HWinObjetAOmbrer, hWinSupportOmbre, STD_INTENSITE, STD_PROFONDEUR, STD_FLOU
    End If
End Sub

Sub Peindre_Ombre(hdc As Long, hWinUnder As Long, Zone As Rect, _
            IntOmbre As Integer, ByVal Flou As Single, Sens As Integer)

'Cette procdure ombre la zone passe en paramtre en assombrissant chaque pixel.
'"Sens" permet de spcifier s'il s'agit de l'ombre droite ou de l'ombre basse.
'   0 pour droite, 1 pour basse, 2 pour coin bas droit
'"HWinUnder" est le handle de la fentre situe sous la fentre  ombrer.

'L'Peindre_Ombre est rgulier sur une distance gale  une proportion de la largeur de l'ombre
'dfinie par "Flou" puis son intensit diminue jusqu' 0 au bord de l'ombre. Le coeff
'd'intensit varie donc sur une droite horizontale (constante) puis dcroit sur un "S"
'(vrifier qu'on a bien deux asymptotes horizontales aux limites) dfini par une quation
'de la forme : C = cos(i) o i est une coordonne.

    Dim Color_Init As Long
    Dim C_Rouge As Long
    Dim C_Bleu As Long
    Dim C_Vert As Long
    Dim CoeffAttenuation As Double 'pour grer le flou de l'ombre (dgrad d'intensit)
    Dim IntOmbreLoc As Integer 'pour grer le flou de l'ombre (dgrad d'intensit)
    'Dim C_Transp As Long
    Dim X1 As Integer
    Dim Y1 As Integer
    Dim X2 As Integer
    Dim Y2 As Integer
    Dim XLimiteFlou As Integer
    Dim YLimiteFlou As Integer
'ncessaire pour les angles puisqu'il faut faire progresser l'indice
'en fonction de la distance au coin cad le rayon du quart de cercle de
'centre le coin infrieur droit.
    Dim Rayon As Integer
        
    X1 = Zone.Left
    Y1 = Zone.Top
    X2 = Zone.Right
    Y2 = Zone.Bottom
'On determine un coeef mult. de l'intensit tel que l'intensit est maximale (coeff = 1) pour
'les petites abcisses et ordonnes et minimale pour les grandes (coeff = 0) selon la progression
'dfinie ci-dessus.

    Dim Temp_Res As Long
   
    Flou = 1 + Flou / 10
    'MsgBox "Flou : " & Flou
    Select Case Sens
        Case 0 'Ombre verticale
            XLimiteFlou = X1 + (X2 - X1) / Flou
            'MsgBox "Ombre verticale ; Flou = " & Flou & vbCrLf & _
            '        "X1 = " & X1 & ", XLimiteFlou = " & XLimiteFlou & ", X2 = " & X2
        Case 1 'Ombre horizontale
            YLimiteFlou = Y1 + (Y2 - Y1) / Flou
            'MsgBox "Ombre horizontale ; Flou = " & Flou & vbCrLf & _
            '        "Y1 = " & Y1 & ", YLimiteFlou = " & YLimiteFlou & ", Y2 = " & Y2
        Case 2 'Ombre coin infrieur droit
            XLimiteFlou = X1 + (X2 - X1) / Flou
            YLimiteFlou = Y1 + (Y2 - Y1) / Flou
        Case 3 'Ombre coin suprieur droit
            XLimiteFlou = X1 + (X2 - X1) / Flou
            YLimiteFlou = Y2 - (Y2 - Y1) / Flou
        Case 4 'Ombre coin infrieur gauche
            XLimiteFlou = X2 - (X2 - X1) / Flou
            YLimiteFlou = Y1 + (Y2 - Y1) / Flou
    End Select
    
    Dim i As Integer
    Dim j As Integer
    For i = X1 To X2
        For j = Y1 To Y2
            Select Case Sens
                Case 0 'Ombre verticale
                    If i < XLimiteFlou Or XLimiteFlou = X2 Then
                        CoeffAttenuation = 1
                    Else
                        'CoeffAttenuation = ((i * (X2 - i)) / (X1 * (X2 - X1)))
                        CoeffAttenuation = AttenueOmbre(XLimiteFlou, X2, i)
                        'Debug.Print CoeffAttenuation
                    End If
                Case 1 'Ombre horizontale
                    If j < YLimiteFlou Or YLimiteFlou = Y2 Then
                        CoeffAttenuation = 1
                    Else
                        CoeffAttenuation = AttenueOmbre(YLimiteFlou, Y2, j)
                    End If
                Case 2 'Ombre coin infrieur droit
                    If i < XLimiteFlou Or XLimiteFlou = X2 Then
                        CoeffAttenuation = 1
                    Else
                        CoeffAttenuation = AttenueOmbre(XLimiteFlou, X2, i)
                    End If
                    If j > YLimiteFlou And Not YLimiteFlou = Y2 Then
                        CoeffAttenuation = CoeffAttenuation * AttenueOmbre(YLimiteFlou, Y2, j)
                    End If
                Case 3 'Ombre coin suprieur droit
                    If i < XLimiteFlou Or XLimiteFlou = X2 Then
                        CoeffAttenuation = 1
                    Else
                        CoeffAttenuation = AttenueOmbre(XLimiteFlou, X2, i)
                    End If
                    If j < YLimiteFlou Then
                        CoeffAttenuation = CoeffAttenuation * AttenueOmbre(YLimiteFlou, Y1, j, False)
                    End If
                Case 4 'Ombre coin infrieur gauche
                    If i > XLimiteFlou Or XLimiteFlou = X1 Then
                        CoeffAttenuation = 1
                    Else
                        CoeffAttenuation = AttenueOmbre(XLimiteFlou, X1, i, False)
                    End If

                    If j > YLimiteFlou Then
                        CoeffAttenuation = CoeffAttenuation * AttenueOmbre(YLimiteFlou, Y2, j)
                    End If
            End Select
            
            'Prise en compte du flou
            IntOmbreLoc = IntOmbre * CoeffAttenuation
            
            'Assombrissement des pixels
            Color_Init = GetPixel(hdc, i, j)
'            C_Rouge = (Color_Init And vbRed)
            C_Rouge = (Color_Init And clRed)
            C_Rouge = C_Rouge - (C_Rouge / 255) * IntOmbreLoc
'            C_Vert = (Color_Init And vbGreen) / (vbRed + 1)
            C_Vert = (Color_Init And clGreen) / (clRed + 1)
            C_Vert = C_Vert - (C_Vert / 255) * IntOmbreLoc
'            C_Bleu = (Color_Init And vbBlue) / (vbGreen + vbRed + 1)
            C_Bleu = (Color_Init And clBlue) / (clGreen + clRed + 1)
            C_Bleu = C_Bleu - (C_Bleu / 255) * IntOmbreLoc
            
            Color_Init = RGB(Correct_RGB(C_Rouge), Correct_RGB(C_Vert), Correct_RGB(C_Bleu))
            Temp_Res = SetPixelV(hdc, i, j, Color_Init)
        Next j
    Next i
End Sub




Sub Ombrer(HWinObjetAOmbrer As Long, hWinSupportOmbre, IntensiteOmbre As Integer, _
                  ProfondeurOmbre As Integer, FlouOmbre As Single)
'Peind une ombre de la fentre de handle "HWinObjetAOmbrer" sur la fentre de handle
'"hWinSupportOmbre" via un tampon mmoire.
'Pour acclrer le traitement, on ne copie pas tous l'cran dans le tampon mais seulement
'une zone rectangulaire un peu plus grande que l'objet  ombrer.
'NB : les repre de coordonnes du tampon mmoire est exactement le mme que celui de l'cran.
'il n'y aucune manip de changement de repre  faire lors des oprations de copie de l'un
'vers l'autre.

'NB : Cette procdure ne fonctionne que sur des fentres au sens systme du terme car il faut un
'handle de fentre.

'    On Error GoTo Err_Ombrer
    
'*****************************************************************************************************
'Declarations
    
    Dim RectOmbre As Rect
    Dim PosXOmbre As Integer
    Dim PosYOmbre As Integer
    Dim HauteurOmbre As Integer
    Dim LargeurOmbre As Integer
    Dim Rect_Fenetre As Rect 'rectangle de la fentre
    Dim Rect_Cl_Support As Rect 'rectangle de la zone client de la fentre support
    Dim Handle_Screen_DC As Long  'handle contexte graphique de l'cran
    Dim hWin_Screen As Long 'handle de la fentre bureau (le desktop-cran)
    Dim hDCSupportOmbre As Long 'DC de la fentre o l'ombre est porte (peinte)
    Dim hWinUnder As Long 'handle de la fentre situe sous la fentre  ombrer. En prvision d'une
                          'gestion de l'tagement de l'ombre sur les fentres situes sous l'objet.
    Dim hObjetDC As Long 'DC de l'objet  ombrer
    
'le buffer graphique
    Dim hMemDC As Long
    Static hMemBitmap As Long
    Dim hPrevBitmap As Long 'handle du bitmap prcdement selectionn
    Dim BufferRect As Rect 'rectangle du buffer
    Dim X_Buffer As Integer 'coordonnes du buffer
    Dim Y_Buffer As Integer 'coordonnes du buffer
    Dim H_Buffer As Integer
    Dim L_Buffer As Integer
    
'*****************************************************************************************************
    hWin_Screen = GetDesktopWindow
    
    Handle_Screen_DC = GetDC(0) 'rcupre le handle du contexte graphique de l'cran
    
    hDCSupportOmbre = GetWindowDC(hWinSupportOmbre)
    
    GetWindowRect HWinObjetAOmbrer, Rect_Fenetre
    GetWindowRect hWinSupportOmbre, Rect_Cl_Support
    
    If ProfondeurOmbre Mod 2 <> 0 Then ProfondeurOmbre = ProfondeurOmbre + 1
    'la valeur de ProfondeurOmbre est rendue paire car les valeurs impaires crent un petit
    'dcalage disgrcieuuhhhx. Et dans la maison, on fait dans l'lgant. Oui mssieur.

'Reprage de la position et des dimensions de l'objet  ombrer
    X_Buffer = Rect_Fenetre.Left
    Y_Buffer = Rect_Fenetre.Top
    L_Buffer = Rect_Fenetre.Right - Rect_Fenetre.Left + ProfondeurOmbre  'de l'ombre  peindre autour de l'objet.
    H_Buffer = Rect_Fenetre.Bottom - Rect_Fenetre.Top + ProfondeurOmbre  'on ajoute "ProfondeurOmbre" pour tenir compte
    'HWinUnder = WindowFromPoint(Rect_Fenetre.Right + 1, Rect_Fenetre.Bottom + 1) 'rcupre le handle de la fentre du dessous

'Modification des dimensions du buffer en fonction de la rgion de clipping
    'cration d'une rgion
    BufferRect.Top = Y_Buffer
    BufferRect.Left = X_Buffer
    BufferRect.Bottom = Y_Buffer + H_Buffer
    BufferRect.Right = X_Buffer + L_Buffer
        
'On dfinit le bitmap  stocker dans le contexte mmoire avec des dimensions suffisantes (un rectangle
'de la taille de l'objet ombr + la taille de l'ombre.
    hMemBitmap = CreateCompatibleBitmap(Handle_Screen_DC, X_Buffer + L_Buffer, Y_Buffer + H_Buffer)
    If hMemBitmap = 0 Then ShowMessage "c'est foutu"
    hMemDC = CreateCompatibleDC(Handle_Screen_DC)
    
'on stocke la zone  redessiner dans le tampon mmoire.
    hPrevBitmap = SelectObject(hMemDC, hMemBitmap)
    'MsgBox "Selected object Id : " & hPrevBitmap & " ; Nouveau : " & hMemBitmap
    'MsgBox "X_Buffer : " & X_Buffer
    
    BitBlt hMemDC, X_Buffer, Y_Buffer, L_Buffer, H_Buffer, _
            Handle_Screen_DC, X_Buffer, Y_Buffer, SRCCOPY
            
'Dbut de la dfinition des ombres
'Ombre verticale
    PosXOmbre = Rect_Fenetre.Right
    PosYOmbre = Rect_Fenetre.Top + ProfondeurOmbre + ProfondeurOmbre / 2
    HauteurOmbre = (Rect_Fenetre.Bottom - Rect_Fenetre.Top) - 1 - ProfondeurOmbre / 2
    LargeurOmbre = ProfondeurOmbre
    RectOmbre.Left = PosXOmbre
    RectOmbre.Top = PosYOmbre
    RectOmbre.Right = PosXOmbre + LargeurOmbre
    RectOmbre.Bottom = PosYOmbre + HauteurOmbre - ProfondeurOmbre
    
    Peindre_Ombre hMemDC, hWinUnder, RectOmbre, IntensiteOmbre, FlouOmbre, 0 ', BasFenetre
'Ombre horizontale
    PosXOmbre = Rect_Fenetre.Left + ProfondeurOmbre + ProfondeurOmbre / 2
    PosYOmbre = Rect_Fenetre.Bottom
    HauteurOmbre = ProfondeurOmbre
    LargeurOmbre = (Rect_Fenetre.Right - Rect_Fenetre.Left) - ProfondeurOmbre / 2
    RectOmbre.Left = PosXOmbre
    RectOmbre.Top = PosYOmbre
    RectOmbre.Right = PosXOmbre + LargeurOmbre - ProfondeurOmbre - 1
    RectOmbre.Bottom = PosYOmbre + HauteurOmbre
    Peindre_Ombre hMemDC, hWinUnder, RectOmbre, IntensiteOmbre, FlouOmbre, 1 ', BasFenetre
    
'Ombre coin infrieur droit
    RectOmbre.Left = RectOmbre.Right + 1
    RectOmbre.Top = RectOmbre.Top '+ 1
    RectOmbre.Right = RectOmbre.Right + ProfondeurOmbre + 1
    'RectOmbre.Bottom = RectOmbre.Bottom 'a change pas non plus
    Peindre_Ombre hMemDC, hWinUnder, RectOmbre, IntensiteOmbre, FlouOmbre, 2 ', BasFenetre
    
'Ombre coin suprieur droit
    'RectOmbre.Left = RectOmbre.left 'a bouge pas
    RectOmbre.Top = RectOmbre.Top - ((Rect_Fenetre.Bottom - Rect_Fenetre.Top) - ProfondeurOmbre / 2) - 1
    RectOmbre.Right = RectOmbre.Right
    RectOmbre.Bottom = RectOmbre.Top + ProfondeurOmbre
    Peindre_Ombre hMemDC, hWinUnder, RectOmbre, IntensiteOmbre, FlouOmbre, 3 ', BasFenetre
    
'Ombre coin infrieur gauche
    RectOmbre.Top = Rect_Fenetre.Bottom
    RectOmbre.Left = Rect_Fenetre.Left + ProfondeurOmbre / 2 - 1
    RectOmbre.Right = RectOmbre.Left + ProfondeurOmbre
    RectOmbre.Bottom = RectOmbre.Top + ProfondeurOmbre
    Peindre_Ombre hMemDC, hWinUnder, RectOmbre, IntensiteOmbre, FlouOmbre, 4 ', BasFenetre
    
'Mise  jour de l'cran avec le tampon mmoire
    BitBlt hDCSupportOmbre, (X_Buffer - Rect_Cl_Support.Left), _
                            (Y_Buffer - Rect_Cl_Support.Top), _
                            L_Buffer, H_Buffer, _
                            hMemDC, X_Buffer, Y_Buffer, SRCCOPY
    
'Libration de la mmoire
    SelectObject hMemDC, hPrevBitmap
    
    'MsgBox "Suppression du bitmap " & hMemBitmap & " : " & DeleteObject(hMemBitmap) & _
    '        vbCrLf & "Ancien bitmap : " & hPrevBitmap
    If DeleteObject(hMemBitmap) = 0 Then ShowMessage "Problme : bitmap mmoire non supprim."
    If DeleteDC(hMemDC) = 0 Then ShowMessage "Problme : DC mmoire non supprim."
    If ReleaseDC(hWin_Screen, Handle_Screen_DC) = 0 Then ShowMessage "Problme : DC mmoire non restitu."
    'MsgBox ReleaseDC(HWin_Screen, Handle_Screen_DC)

Exit_Ombrer:
'    Exit Sub
    
'Err_Ombrer:
'    Select Case Err
'        Case Else
'            MsgBox "Erreur dans la procdure " & Chr(34) & "Ombrer" & Chr(34) & "."
'            On Error GoTo 0
'            Err.Raise Err 'on propage l'erreur pour gestion par l'application appelante
'    End Select
'    GoTo Exit_Ombrer
    
End Sub










