'Modificado para RapidQ por Jordi Ramos 26/05/2004

'*****************************************************************************************************
'TYPES
Type POINTAPI
  x As Long
  y As Long
End Type

Type Rect
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

'*****************************************************************************************************
'CONSTANTES

'Constantes pour appels API
Const SRCCOPY = &HCC0020

'Constantes pour fonctions locales
Const STD_INTENSITE = 100 'Intensit standard
Const STD_PROFONDEUR = 15 'Prodondeur standard
Const STD_FLOU = 30 'Flou standard

'****************************************************************************************************
'API WINDOWS UTILISEES

Declare Function GetDC Lib "user32" Alias "GetDC" _
                 (hwnd As Long) As Long
'Rcupre le handle du contexte priphrique graphique de la fentre  ombrer.

Declare Function GetDesktopWindow Lib "user32" Alias "GetDesktopWindow"() As Long
'Rcupre le handle de la fentre cran (le bureau).

Declare Function GetWindowDC Lib "user32" Alias "GetWindowDC" _
                 (hwnd As Long) As Long
'Rcupre le handle du contexte priphrique graphique de la fentre de handle "hwnd".

'Copie les pixels d'une zone d'un bitmap dans une zone d'un autre bitmap. Ici, on l'utilise
'pour transferer la portion de l'cran  ombrer en mmoire et la repeindre  l'cran une fois
'l'ombrage effectu.
Declare Function BitBlt Lib "gdi32" Alias "BitBlt" _
                 (hDestDC As Long, _
                  x As Long, y As Long, _
                  nWidth As Long, nHeight As Long, _
                  hSrcDC As Long, _
                  xSrc As Long, ySrc As Long, _
                  dwRop As Long) As Long
'Description de "BitBlt" :
'   hDestDC :    le handle du contexte priphrique graphique cible (destinataire de l'image)
'   x, y, nWidth, nHeight : coordonnes du rectangle cible
'   hSrcDC : le handle du contexte priphrique graphique source
'   xSrc, ySrc : origine du bitmap source
'   dwRop : Type de copie. Spcifie l'opration de composition de l'image avec le fond.
'           Ici, ce sera toujours une copie simple avec la valeur SRCCOPY ci-dessous.
                                            
'Rcupre la valeur RVB d'un pixel.
Declare Function GetPixel Lib "gdi32" Alias "GetPixel" _
                 (hdc As Long, x As Long, y As Long) As Long

'Dfinit la valeur RVB d'un pixel.
Declare Function SetPixelV Lib "gdi32" Alias "SetPixelV" _
                 (hdc As Long, x As Long, y As Long, crColor As Long) As Long

'Rcupre le rectangle d'une fentre (structure "Rect")
Declare Function GetWindowRect Lib "user32" Alias "GetWindowRect" _
                 (hwnd As Long, lpRect As Rect) As Long
'Rcupre le rectangle de la zone client (hors menus, ascensseurs, barres de titre et d'outils)
'd'une fentre (structure "Rect")
'Public Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As Rect) As Long

'Dfinit l'objet graphique sur lequel vont tre effectues les oprations graphiques.
Declare Function SelectObject Lib "gdi32" Alias "SelectObject" _
                 (hdc As Long, hObject As Long) As Long

'Cre en mmoire un contexte priphrique compatible avec le contexte priphrique graphique spcifi.
Declare Function CreateCompatibleDC Lib "gdi32" Alias "CreateCompatibleDC" _
                 (hdc As Long) As Long

'Cre en mmoire un bitmap compatible avec le contexte priphrique graphique spcifi.
Declare Function CreateCompatibleBitmap Lib "gdi32" Alias "CreateCompatibleBitmap" _
                 (hdc As Long, nWidth As Long, nHeight As Long) As Long

'Supprime un objet graphique. Ralloue les ressources utilises.
Declare Function DeleteObject Lib "gdi32" Alias "DeleteObject" _
                 (hObject As Long) As Long

'Supprime un contexte priphrique graphique. Ralloue les ressources utilises.
Declare Function DeleteDC Lib "gdi32" Alias "DeleteDC" _
                 (hdc As Long) As Long

'Libre un contexte priphrique graphique. Le rend disponible pour d'autres utilisateurs ventuels.
'Pas sur que ce soit indispensable dans le cas prsent. Mis par prudence.
Declare Function ReleaseDC Lib "user32" Alias "ReleaseDC" _
                 (hwnd As Long, hdc As Long) As Long

'Public Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
'Cette API est utile pour rcuprer le handle de la fentre situe sous la fentre 
'ombrer et grer ainsi un ventuel tagement de l'ombre. Avis aux perfectionnistes...



'fonctions pour dbuggage
'Public Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
'Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long


